package com.bpcl.lpg.core.interceptor;

import com.bpcl.core.model.BPCLAccountModel;
import de.hybris.platform.servicelayer.interceptor.InterceptorException;
import java.util.stream.Collector;
import java.util.stream.Collectors;
import com.bpcl.lpg.core.model.LPGDomesticConnectionModel;
import java.util.Set;
import java.util.Collection;
import org.apache.commons.collections4.CollectionUtils;
import de.hybris.platform.servicelayer.interceptor.InterceptorContext;
import de.hybris.platform.servicelayer.i18n.L10NService;
import com.bpcl.core.model.BPCLCustomerModel;
import de.hybris.platform.servicelayer.interceptor.ValidateInterceptor;

public class BpclB2BCustomerDomesticConnectionValidateInterceptor implements ValidateInterceptor<BPCLCustomerModel>
{
    private L10NService l10NService;
    
    public void onValidate(final BPCLCustomerModel model, final InterceptorContext ctx) throws InterceptorException {
        if (CollectionUtils.isNotEmpty((Collection)model.getBpclAccounts())) {
            final Set<BPCLAccountModel> domesticConnection = (Set<BPCLAccountModel>)model.getBpclAccounts().stream().filter(bpclAccountModel -> bpclAccountModel instanceof LPGDomesticConnectionModel).collect(Collectors.toSet());
            if (CollectionUtils.isNotEmpty((Collection)domesticConnection) && domesticConnection.size() > 1) {
                throw new InterceptorException(this.getL10NService().getLocalizedString("error.invalid.number.of.domestic.connection"));
            }
        }
    }
    
    public L10NService getL10NService() {
        return this.l10NService;
    }
    
    public void setL10NService(final L10NService l10nService) {
        this.l10NService = l10nService;
    }
}
